# mypy: disable-error-code="misc, override, no-redef"

import pxr.Usd as Usd
import pxr.UsdGeom as UsdGeom
import pxr.UsdShade as UsdShade
import pxr.UsdUtils.constantsGroup
from pxr.UsdUtils.constantsGroup import ConstantsGroup as ConstantsGroup
from typing import ClassVar

class BoundingBoxAttribute(CustomAttribute):
    def __init__(self, currentPrim, rootDataModel) -> None: ...
    def Get(self, frame): ...
    def GetName(self): ...

class ComputedPropertyFactory:
    """Creates computed properties."""
    def __init__(self, rootDataModel) -> None: ...
    def getComputedProperty(self, prim, propName):
        """Create a new computed property from a prim and property name."""

class ComputedPropertyNames(pxr.UsdUtils.constantsGroup.ConstantsGroup):
    """Names of all available computed properties."""
    LOCAL_WORLD_XFORM: ClassVar[str] = ...
    RESOLVED_FULL_MATERIAL: ClassVar[str] = ...
    RESOLVED_PREVIEW_MATERIAL: ClassVar[str] = ...
    WORLD_BBOX: ClassVar[str] = ...
    _all: ClassVar[tuple] = ...

class CustomAttribute:
    def __init__(self, currentPrim, rootDataModel) -> None: ...
    def Get(self, frame): ...
    def GetName(self): ...
    def GetPrimPath(self): ...
    def GetTypeName(self): ...
    def IsVisible(self): ...

class LocalToWorldXformAttribute(CustomAttribute):
    def __init__(self, currentPrim, rootDataModel) -> None: ...
    def Get(self, frame): ...
    def GetName(self): ...

class ResolvedBoundMaterial(CustomAttribute):
    def __init__(self, currentPrim, rootDataModel, purpose) -> None: ...
    def Get(self, frame): ...
    def GetName(self): ...

class ResolvedFullMaterial(ResolvedBoundMaterial):
    def __init__(self, currentPrim, rootDataModel) -> None: ...

class ResolvedPreviewMaterial(ResolvedBoundMaterial):
    def __init__(self, currentPrim, rootDataModel) -> None: ...

def _GetCustomAttributes(currentPrim, rootDataModel): ...
